/* File: expx2.c
   Calculate the approximate value of exp(0.5) iteratively */
#include <stdio.h>
#include <math.h>  /* for pow() and exp() */
#include <float.h> /* for FLT_EPSILON */

int main() {
   int i;
   double x, expx, term;

   x = 0.5;
   expx = 1.0;
   term = 1.0;
   i = 1;
   while(term>FLT_EPSILON) { /* continue if pow(x,i)/i! > epsilon  */
      term *= x/(double)i;
      expx += term;
      i++;
   }
   printf("expx   = %f\n", expx);
   printf("exp(x) = %f\n", exp(x));
   return 0;
}
