/* File: accelfunm.c
   Calculate the acceleration. 
   Both force and acceleration are calculated using functions */
#include <stdio.h>
#define M_G   9.81  /* gravitational acceleration constant g */

/* definition of the function force() 
   The data type of the argument and return value of
   the function is double */
double force(double t) {
    double p;       /* declare local variable */

    p = 4*(t-3)+20;
    return p;       /* return force p */
}

/* function accel() has multiple arguments for t, mu, and m */
double accel(double t, double mu, double m) {
    double a, p;    /* declare local variables */

    /* calculate force by calling function force() */
    p = force(t);  
    a = (p-mu*m*M_G)/m;
    return a;       /* return acceleration a */
}

int main() {
    double a, mu, m, t; /* declare local variables */

    mu = 0.2;
    m = 5.0;
    t = 2.0;
    /*  call function accel() to calculate acceleration;
        inside function accel(), it calls another function force() */
    a = accel(t, mu, m);
    printf("Acceleration a = %f (m/s^2)\n", a);
    return 0;
}
