/* File: accelprot.c
   Calculate the acceleration.
   Both force and acceleration are calculated using functions.
   With function prototypes, main() function is at the beginning */
#include <stdio.h>
#define M_G   9.81  /* gravitational acceleration constant g */

/* function prototypes for force() and and accel() */
double force(double t);
double accel(double t, double mu, double m);

/* main() function appears before the definitions of
   called functions force() and accel() are defined */
int main() {
    double a, mu, m, t;
    int i;

    mu = 0.2;
    m = 5.0;
    t = 2.0;
    a = accel(t, mu, m);
    printf("Acceleration a = %f (m/s^2)\n", a);
    return 0;
}

double force(double t) {
    double p;

    p = 4*(t-3)+20;
    return p;
}

double accel(double t, double mu, double m) {
    double a, p;

    p = force(t);
    a = (p-mu*m*M_G)/m;
    return a;
}
