/* File: sinr.c 
   Calculate function sinr(x, y)=sin(sqrt(x*x + y*y))/sqrt(x*x + y*y)
   using function sinr() for x from -10 to 10 with step size 10, 
   and for y from -10 to 10 with step size 10. */
#include <stdio.h>  
#include <math.h>   /* for sin() and sqrt() */

/* function definition for sinr() */
double sinr(double x, double y) {
    double r, retval;

    r = sqrt(x*x + y*y);
    retval = sin(r)/r;
    return retval;
}

int main() {
    double x, x0, xf, xstep,
           y, y0, yf, ystep, result;
    int i, j, nx, ny;

    printf("      x          y    sinr(x,y)\n");
    printf("  -----------------------------\n");
    x0 = -10.0;                  /* initial value for x */
    xf = 10.0;                   /* final value for x */
    xstep = 10.0;                /* step size for x */
    nx = (xf - x0)/xstep + 1;    /* num of points for x */
    y0 = -10.0;                  /* initial value for y */
    yf = 10.0;                   /* final value for y */
    ystep = 10.0;                /* step size for y */
    ny = (yf - y0)/ystep + 1;    /* num of points for y */

    /* use nested two for-loops for x and y variables */
    for(i = 0; i < nx; i++) {
       x = x0 + i*xstep;         /* calculate value for x */
       /* for each x value, y varies from y0 to yf with ystep */
       for(j = 0; j <ny; j++) {
          y = y0 + j*ystep;      /* calculate value for y */

          /* calculate sinr(x, y) by a function and display the result */
          result = sinr(x, y);
          printf("%10.4f %10.4f %8.4f\n", x, y, result);
       }
    }
    return 0;
}
