/* File: usevoid.c
   Use data type 'void' in function */
#include <stdio.h>

/* use 'void' to indicate that the function has no argument */
int func1(void) {    /* no argument */
    printf("func1() is called\n");
    return 0;        /* function returns 0 */
}

/* use 'void' to indicate that function has no return value */
void func2(int i) {  /* no return value */
    if(i <= 0) {
       printf("i in func2() = %d\n", i);
       return;       /* no expression following return */
    }
    printf("i in func2() = %d\n", i);
}

int main() {
    int status;      /* declare local variable */

    /* returned value from func1() is assigned to status */
    status = func1(); 
    printf("status = %d\n", status);
    func1();         /* returned value from func1() is ignored */
    func2(10);       /* no return value from func2() */ 
    func2(-10);      /* no return value from func2() */ 
    return 0;
}
