/* File: basictypesize.c
   Obtain the sizes of basic data types in C99
   if C99 is supported. Otherwise, exclude new data types in C99.
   Compile in gcc, use command 'gcc -std=c99 basictypesize.c' */
#include <stdio.h>
#include <stddef.h>   /* for size_t */
/* this code block using C99 features 
   is included only for C99 comforming inplementation */
#if __STDC_VERSION__==199901L
#include <stdbool.h>  /* for bool */
#include <complex.h>  /* for complex */
#endif

int main() {
    printf("sizeof(char) = %d\n", sizeof(char));
    printf("sizeof(short) = %d\n", sizeof(short));
    printf("sizeof(int) = %d\n", sizeof(int));
    printf("sizeof(long) = %d\n", sizeof(long));
    printf("sizeof(float) = %d\n", sizeof(float));
    printf("sizeof(double) = %d\n", sizeof(double));
    printf("sizeof(long double) = %d\n", sizeof(long double));
    printf("sizeof(pointer) = %d\n", sizeof(int *));
    printf("sizeof(size_t) = %d\n", sizeof(size_t));
/* this code block is included only for C99 comforming inplementation */
#if __STDC_VERSION__==199901L
    printf("sizeof(bool) = %d\n", sizeof(bool));
    printf("sizeof(long long) = %d\n", sizeof(long long));
    printf("sizeof(float complex) = %d\n", sizeof(float complex));
    printf("sizeof(complex) = %d\n", sizeof(complex));
    printf("sizeof(double complex) = %d\n", sizeof(double complex));
    printf("sizeof(long double complex) = %d\n", sizeof(long double complex));
#endif
    return 0;
}
