/* File: staticfile.c
   Use 'static' specifier for variables in file scope */
#include <stdio.h>

/* variables x and function func2() in file scope
   are accessible only in this file 'staticfile.c' */
static int x = 10;  /* declare static variable x */
static int func2(void); /* declare static function func2() */

/* function func1() in program scope.
   func1() uses variables and call function func2() in file scope */
int func1(void) {
    func2();  /* call static function */
    /* use variable x in file scope */
    printf("static x in func1()  = %d\n", x);
    x++;      
    return 0;
}

static int func2(void) {
    /* use variable x in file scope */
    printf("static x in func2() = %d\n", x);
    x++;    
    return 0;
}
  
