/* File: gpa.c
   Calculate statistical info for a list of GPA's 
   using the statistics library statlab.h and statlib.c */
#include <stdio.h>
#include "statlib.h" /* the header file for statistics lib */

int main() {
    /* the database for students' GPA in a class */
    double data[] = {3.33, 3, 3.1, 3.93, 2.3, 2.31, 3.99, 2.8, 2.9, 3.7};
    double gpa; 
    int i, totnum, num;
   
    /* find the total number of elements in array 'data' */
    totnum = sizeof(data)/sizeof(double); 
    printf("The total number of students is %d\n", totnum);

    /* use the statlib to get the result, and then disply it */
    gpa = mean(totnum, data);
    printf("The average GPA for all students is %.2f\n", gpa);
    gpa = maximum(totnum, data);
    printf("The highest GPA for all students is %.2f\n", gpa);
    gpa = minimum(totnum, data);
    printf("The lowest GPA for all students is %.2f\n", gpa);
    gpa = stdDeviation(totnum, data);
    printf("The standard deviation of GPA for all students is %.2f\n", gpa);
    num = aboveVal(totnum, data, 3.0);
    printf("The number of students with GPA 3.0 or above is %d\n", num);
    sort(totnum, data);
    printf("The student record sorted in ascending GPA:\n");
    for(i=0; i< totnum; i++) {
        printf("%.2f ",data[i]);
    }
    printf("\n");
    gpa = median(totnum, data);
    printf("The median GPA for all students is %.2f\n", gpa);
    return 0;
}
