/* File: hatarray.cpp 
   Plot function sinr(x, y)=sin(sqrt(x*x + y*y))/sqrt(x*x + y*y)
   using function sinr() for x from -10 to 10 80 points,
   and for y from -10 to 10 with step size 100. */

#include <math.h>
#include <chplot.h>

#define NUMX 80
#define NUMY 100

int main() {
    /* declare and initialize with variables for x0, xf, y0, yf */
    double x0 = -10.0, xf = 10.0, y0 = -10.0, yf = 10.0, r;
    /* declare arrays for x, y, and z coordinates. Number of elements for
       z is related to number of points for x and y by NUMX*NUMY */
    double x[NUMX], y[NUMY], z[NUMX*NUMY];
    int i, j;

    /* fill array y with values in the range [y0, yf] linearly */
    for(j=0; j<NUMY; j++)
       y[j] = y0 + j*(yf-y0)/(NUMY-1);
    for(i=0; i<NUMX; i++) {
       /* fill array x with values in the range [x0, xf] linearly */
       x[i] = x0 + i*(xf-x0)/(NUMX-1);
       /* fill array z with values in the ranges [x0, xf] and [y0, yf] */
       for(j=0; j<NUMY; j++) {
         r = sqrt(x[i]*x[i] + y[j]*y[j]);
         z[i*NUMY+j] = sin(r)/r;
       }
    }
    /* plot 3D surface using plotxyz() */
    plotxyz(x, y, z, NUMX, NUMY, "function sinr(x, y)", "x", "y", "sinr");
    return 0;
}
