/* File: polynomial.c
   Evaluate a polynomial iteratively */
#include <stdio.h>

#define N 6  /* 5th order polynomial with 6 coefficients */

int main() {
    /* 5th order polynomial 2x^5 - 5x^4 + 10x^3 - 10x^2 + 5x - 1 */
    double c[N]={2, -5.0, 10.0, -10.0, 5.0, -1.0}, /* polynomial coefficients */
           p,       /* polynomial value */
           x;       /* x in the polynomial */
    int i;          /* variable for array index */

    x=0.1;          /* set x value */ 
    p = c[0];       /* initialize p for iterative evaluation */
    for(i=1; i<N; i++) { 
       p = p*x + c[i];  /* iterative evaluation of polynomial */
    }
    printf("x=%.2f  p=%f\n", x, p);
    return 0;
}
