/* File: search.c 
   Linear search for a value in an array */
#include <stdio.h>

#define N 8   /* number of elements for array a */

/* linear search for val in data[]. return index of element
   if there is a match; otherwise, return -1 */
int lsearch(int n, double data[], double val) { 
    int i;

    for(i = 0; i < n; i++) { /* search through each element */
        if(val == data[i]) { /* or use fabs(val - data[i]) < FLT_EPSILON */ 
           return i;    /* return location (index) for the value */
        }
    }
    return -1;          /* return -1 if no match */
}

int main() {
    /* declare array a with initialization */
    double a[N] = {3.0, 21.0, 0.0, -3.0, 34.0, -14.0, 45.0, 18.0};
    double value = -14.0; /* the value to be searched */
    int loc;        /* location of the value in an array */
    int i;
    
    printf("The original data:\n"); 
    for(i = 0; i < N; i++) {  /* print the original array */
        printf("%g ", a[i]);
    }

    /* search value in a */
    loc = lsearch(N, &a[0], value); 
    /* or loc = lsearch(N, a, value);  */

    if(loc != -1) {             /* found it */
        printf("\nFind %g in element %d\n", value, loc);
    } 
    else {                      /* did not find it */
        printf("\nCannot find %g in array\n", value);
    }

    return 0;
}
