/* File: sranda.c
   Roll a six-sided die 6,000 times randomly,
   calculate the frequencies for each face. 
   Use an array to keep frequency for each face */
#include <stdio.h>
#include <stdlib.h>   /* for using srand() and rand() */
#include <time.h>     /* for using time() */

#define N 6           /* the number of sides of a die */

int main() {
   int face,          /* face in each roll */
       rollcount,     /* roll count number */
       freq[N]={0};   /* array of frequencies for each face, 
                         initialize each element with 0 */

   srand(time(NULL)); /* seed the random number generator */
   /* use a loop to roll N*1,000 times */
   for (rollcount = 1; rollcount <= N*1000; rollcount++) {
      /* generate a random number in [1, N] */
      face = 1 + rand() % N;
      /* the corresponding frequency for the face is incremented.
         array index for freq[] ranges from 0 to N-1 */
      freq[face-1] += 1;
   }
   
   /* display the result */
   printf("%s%12s\n", "Face", "Frequency");
   for(face = 1; face <= N; face++ ) {
       printf("  %2d%12d\n", face, freq[face-1]);
   }
   return 0;
}
