/* File: weeklyhit.c
   Calculate the mean value for weekly hit and daily hit of a Web page */
#include <stdio.h>
#define WEEK 5      /* 5 rows for a total number of 5 weeks in the data */
#define DAY 7       /* 7 columns for each day in each week */

int main() { 
    /* The daily hit is recorded in an array with row for a week and column 
       for each day in week. Alternatively, the array can be declared as
       int a[][DAY] = {367, 654, 545, 556, 565, 526, 437, */
    int a[WEEK][DAY] = {367, 654, 545, 556, 565, 526, 437,
                        389, 689, 554, 526, 625, 537, 468,
                        429, 644, 586, 626, 652, 546, 493,
                        449, 689, 597, 679, 696, 568, 522,
                        489, 729, 627, 729, 737, 598, 552};
    /* array indexes, weekly total num of hits, and daily total num of hits.
       initialize dailytotal to 0 */
    int i, j, weektotal, dailytotal = 0; 
    double meanval; /* a floating-point number for the mean value */

    printf("Week Mean hit\n");
    printf("-------------\n");
    for(i = 0; i < WEEK; i++) { /* loop through the row for each week */
        weektotal = 0;          /* initialize weektotal to 0 for each week */
        /* loop through the column for each day in a week */
        for(j = 0; j < DAY; j++) { 
            weektotal += a[i][j];  /* add daily hit number to weektotal */
            dailytotal += a[i][j]; /* add daily hit number to dailytotal */
        }
        meanval =  (double)weektotal/(double)DAY; /* mean weekly hit */
        printf(" %d%10.2f\n", i+1, meanval);      /* output mean weekly hit */
    }
    meanval =  (double)dailytotal/(double)(WEEK*DAY); /* mean daily hit */
    printf("The mean value for daily hit is %.2f\n", meanval); /* output */
    return 0;
}
