/* File: weeklyhit2.c
   Calculate the mean value for weekly hit and daily hit of a Web page 
   using a statistic lib */
#include <stdio.h>
#include "statlib.h" /* header file for statistics lib */
#define WEEK 5       /* 5 rows for a total number of 5 weeks in the data */
#define DAY 7        /* 7 columns for each day in each week */

int main() { 
    /* The daily hit is recorded in an array with row for a week and column 
       for each day in week. Alternatively, the array can be declared as
       double a[][DAY] = {367, 654, 545, 556, 565, 526, 437, */
    double a[WEEK][DAY] = {367, 654, 545, 556, 565, 526, 437,
                        389, 689, 554, 526, 625, 537, 468,
                        429, 644, 586, 626, 652, 546, 493,
                        449, 689, 597, 679, 696, 568, 522,
                        489, 729, 627, 729, 737, 598, 552};
    /* array index */
    int i;
    double meanval;/* a floating-point number for the mean value for each row */
    double meanvals = 0.0; /* mean values for all rows */

    printf("Week Mean hit\n");
    printf("-------------\n");
    for(i = 0; i < WEEK; i++) { /* loop through the row for each week */
        meanval = mean(DAY, &a[i][0]);
        meanvals += meanval;                  /* add a row of mean value */
        printf(" %d%10.2f\n", i+1, meanval);  /* output mean weekly hit */
    }
    meanval =  meanvals/WEEK; /* mean daily hit */
    printf("The mean value for daily hit is %.2f\n", meanval); /* output */
    return 0;
}
