/* File: dayhit.c 
   Calculate the mean value for accessing a Web site each day in a week */
#include <stdio.h>
#define WEEK 5      /* 5 rows for a total number of 5 weeks in the data */
#define DAY 7       /* 7 columns for each day in each week */

/* declare 'day' as an array of pointer to const char as
   string for each day in a week, day has a static storage duration. */
const char *day[] = {"Sunday", "Monday", "Tuesday", "Wednesday", 
                     "Thursday", "Friday", "Saturday"};

int main() {
   /* The daily hit is recorded in an array with row for a week and
       column for each day in week. */ 
    int a[][DAY] = {367, 654, 545, 556, 565, 526, 437,
                    389, 689, 554, 526, 625, 537, 468,
                    429, 644, 586, 626, 652, 546, 493,
                    449, 689, 597, 679, 696, 568, 522,
                    489, 729, 627, 729, 737, 598, 552};
    /* array indexes, day total num of hits */
    int i, j, daytotal;
    double meanval; /* a floating-point number for the mean value */


    printf("%-10s%-10s\n", "Day", "Mean hit");
    printf("------------------\n");
    for(j = 0; j < DAY; j++) { /* loop through the column for each day */
        daytotal = 0;          /* initialize daytotal to 0 for each day */
        for(i = 0; i < WEEK; i++) {
            daytotal += a[i][j]; /* add day hit number to daytotal */
        }
        meanval =  (double)daytotal/(double)WEEK; /* mean day hit */
        printf("%-10s%8.2f\n", day[j], meanval);  /* output day hit */
    }
    return 0;
}
