/* File: poperators.c 
   Demonstrate pointer, indirection operation, and address operation */
#include <stdio.h>

int main() {
    int i, j, *p; /* declare i and j as int, p as pointer to int */

    i = 10;    /* i is assigned with 10 */
    j = 0;     /* j is assigned with 0 */
    p = &i;    /* p is assigned with the address of i.
                  p points to i, *p <==> i */
    printf("The value of i is %d\n", i);
    printf("The value of j is %d\n", j);
    printf("The address of i is %p\n", &i);
    printf("The value of p is %p\n", p);
    printf("The value of *p is %d\n", *p);

    *p = 20;    /* The memory pointed by p is assigned with 20;
                   effectively, i is assigned with 20 */
    j = *p;     /* j is assigned with the value pointed by p,
                   effectively, j is assigned with the value of i */
    printf("After indirection operations\n");
    printf("The value of i is %d\n", i);
    printf("The value of j is %d\n", j);
    printf("The address of i is %p\n", &i);
    printf("The value of p is %p\n", p);
    printf("The value of *p is %d\n", *p);
    return 0;
}
