/* File: qsortbsearch.c 
   Sort arrays of integers and doubles using quick sort qsort(), and
   binary search an element based on the key using the C standard functions */
#include <stdio.h>
#include <stdlib.h>  /* for qsort() and bsearch() */
#define N 10         /* number of elements for arrays */

/* function to compare doubles */
int compared(const void *a, const void *b) {
    /* cast objects pointed by the generic pointer as an object of 
       double type before comparison */
    double a1 = *(double*)a, b1= *(double*)b;

    /* compare a1 and b1 */
    if(a1 > b1)
      return 1;
    else if(a1 < b1)
      return -1;
    else
      return 0;
}
/* function to compare integers */
int comparei(const void *a, const void *b) {
    /* cast objects pointed by the generic pointer as an object of int type */
    return *(int *)a - *(int *)b; 
}

int main() {
    /* declare and initialize arrays of int and double types */
    int i, a[N] = {1, 3, 6, 5, 8, 7, 9, 6, 2, 0}, keyi = 5, *resi;
    double b[N] = {1.0,3.0,6.0,5.0,8.0,7.0,9.0,6.0,2.0,0}, keyd = 5.0, *resd;

    /* print the original array, sort array, print sorted array, search key */
    printf("Original array a:");      /* print the orignal array */
    for(i=0; i<N; i++)
        printf("%d ",a[i]);
    qsort(a,N,sizeof(int),comparei);  /* sort array a in ascending order */
    printf("\nSorted array a:  ");    /* print the sorted array */
    for(i=0; i<N; i++) 
        printf("%d ",a[i]);
    resi = bsearch(&keyi, a, N, sizeof(int), comparei); /* search keyi */
    if(resi != NULL) /* resi is not NULL when there is a matching element */
        printf("\n*resi for key of 5 is %d\n", *resi);

    /* print the original array, sort array, print sorted array, search key */
    printf("\nOriginal array b:");      /* print the orignal array */
    for(i=0; i<N; i++)
        printf("%.1f ",b[i]);
    qsort(b,N,sizeof(double),compared); /* sort array b in ascending order */
    printf("\nSorted array b:  ");      /* print the sorted array */
    for(i=0; i<N; i++) 
        printf("%.1f ",b[i]);
    resd = bsearch(&keyd, b, N, sizeof(double), compared); /* search keyd */
    printf("\n*resd for key of 5.0 is %.1f\n", *resd);
    return 0;
}
