/* File: returnfunptr.c
   Function returns a pointer to functions */
#include <stdio.h>

/* declare FUNCPTR as a data type of pointer to functions
   with an argument of type double and return type int */ 
typedef int (*FUNCPTR)(double f);

/* a function with an argument of type double and return type int */ 
int fun(double f) {
    printf("f = %f\n", f);
    return 0;
}

/* function returns a pointer to function with an argument of 
   type double and return type int. The alternative function header is
       int (*fun2(int i))(double f) */
FUNCPTR fun2(int i)  
{
   if(i)            /* if i is not zero, return fun */
     return fun;
   else 
     return NULL;
}

int main() {
    FUNCPTR pf;    /* declare pf as a pointer to function */ 

    pf = fun2(1);  /* fun2() returns 'fun' */
    pf(20.0);      /* call function 'fun()' indirectly by pf() */
    return 0;
}
