/* File: returnptr.c
   Demonstrate functions return pointers to variables
   and dynamically allocated memory */
#include <stdio.h>
#include <stdlib.h> /* for malloc(), free(), and NULL */

int g = 10;     /* declare and initialize global variable */

/* function returns a pointer to variable of static storage duration */
int *func1(void) {
    int *p;     /* declare a pointer */
    p = &g;
    return p;   /* return a pointer to a global variable g */
}

/* function returns a pointer to dynamically allocated memory */
void *allocMemory(size_t size) {
    void *p;          /* declare a pointer */
    p = malloc(size); /* allocate memory */
    if(p == NULL) {
       printf("Error: allocMemory() failed, no memory\n");
    }
    /* return a pointer to the dynamically allocated memory, or NULL */
    return p;   
}

/* function returns a pointer to the address of a variable of 
   automatic storage duration. */
char *func3(int n, const char *str) {
    int *p;     /* declare a pointer */
   
    if(n >= 3)  /* if array a has more than 4 elements */
       p = a+3;  
    else
       p = NULL;
    return p;   /* return the address of 4th element of array a */
}

int main() {
    int a[5] = {1, 2, 3, 4, 5}; /* declare and initialize an array */
    int *p1, *p2, *p3;          /* declare variables of pointer types */
   
    p1 = func1();     /* this is equivalent to p = &g */
    p2 = func2();     /* allocate memory for p */
    *p2 = 10;         /* use allocated memory */
    free(p2);         /* free the allocated memory for p */
    p3 = func3(5, a); /* p points to a[3], *p has value 4 */
    return 0;
}
