/* File: returnptrchr.c
   functions return a pointer to the memory of the passed argument */
#include <stdio.h>
#include <stdlib.h> /* for NULL */

/* Function strchar() function  returns  a  pointer  to  the  first
   occurrence  of char c in string s, or a null pointer if  c  does 
   not occur in the  string. */  
char *strchar(const char *s, int c) {
    char chr = c;      /* cast int representation of c in c */
    /* compare c with each character in string s.
       The last character of the string is '\0' */
    while(*s != chr) {    
       if(*s == '\0')  /* if c does not occur in the string, return NULL */ 
          return NULL;
       s++;            /* increment to the next element */
    }
    /* cast the result to type 'char *' from 'const char *' */
    return (char *)s; 
}

int main() {
    /* declare and initialize a const string */
    const char *str = "the passed string"; 
    char c = 's',       /* char to be found in string str */
             *p;        /* pointer to the address of the character 
                           of first 's' */

    /* call function strchar() to  find the first char 's' in string str */
    p =  strchar(str, c); 
    /* display the address of string str and p, as well as the character 
       pointed by p */
    printf("str = %p\n", str);
    printf("p = %p\n", p);
    printf("*p = %c\n", *p);
    return 0;
}
