/* File: strcopy.c
   Copy a string. The source string is const-qualified */
#include <stdio.h>

/* Function copying string from sp to dp.
   string pointed to by sp is not modified inside the function.
   To make this intention clear, it is const-qualified so that
   it cannot be modified inside the function.  */  
char *strcopy(char *dp, const char *sp) {
    char *retp = dp;
    while(*sp != '\0') { /* copy each character in the string
                            until the null terminating character is reached */
      /* copy a character, advance pointers dp and sp to the next elements */
      *dp++ =  *sp++;    
    }
    *dp = '\0'; /* fill the last element with the null terminating character */
    return retp;  /* return the passed dp */
}

int main() {
     const char *src = "original string"; /* original string */
     char dest[100];                      /* destination string */
 
     strcopy(dest, src);                  /* copy src to dest */
     printf("dest = %s\n", dest);         /* display the copied string */
     return 0;
}
