/* File: geturl.c
   Get the URL Web address from the terminal input */
#include <stdio.h>      /* printf(), fgets() */
#include <string.h>     /* for strstr(), strchr(), strcpy(), strncpy() */
#define LINESIZE 1024   /* the maximum input line length */

int main() {
    /* declare strings line for the input string, url for URL address 
       beginptr for the beginning of the URL address, 
       endptr for the end of the URL address */
    char line[LINESIZE], url[LINESIZE], *beginptr, *endptr;
    int len;  /* the len of the URL address */

    printf("Please input a string with URL address such as\n");
    printf("\"http://www.softintegration.com\"\n");
    fgets(line, LINESIZE, stdin); /* get the user input */
    /* find "http:// in the string */
    /* There might be multiple URL addresses in the user input line */
    while (beginptr = strstr(line, "\"http://")) 
    {
        beginptr++; /* skip " in "http:// */
        /* find the closing " */
        endptr = strchr(beginptr, '"');
        if(endptr != NULL)  /* when there is " */
        {
            len = endptr - beginptr; /* calculate the length of URL address */
            strncpy(url, beginptr, len); /* copy URL address to url */
            url[len] = '\0';        /* append a null character for url */
            printf("%s\n",url );    /* got a URL, print it */
            strcpy(line, endptr);   /* update string line to find next URL */
        }
        else { /* set line to a null terminating character to quit while-loop */
            line[0] = '\0';
        }
    }
    return 0;
}
