/* File: strcpy.c 
   Copy a string using the C standard function */
#include <stdio.h>
#include <string.h>             /* for strcpy() */ 
#include <stdlib.h>             /* for malloc(), free(), exit() */

int main() {
    char *name, str[10];        /* declare strings */

    /* allocate the memory dynamically for string 'name' */
    name = (char *)malloc(sizeof(char)*(strlen("John")+1));
    if(name == NULL) {
      printf("Error: no memory\n");
      exit(EXIT_FAILURE);       /* exit with failure status */
    }
    strcpy(name, "John");       /* copy string "John" to name */
    printf("name = %s\n", name);/* print string name */

    strcpy(str, name);          /* copy string name to str */
    printf("str = %s\n", str);  /* print string str */
    free(name);                 /* free memory allocated for name */
    return 0;
}
