/* File: strmemory.c 
   Dynamically allocate memory for a string */
#include <stdio.h>
#include <string.h>    /* for strcpy(), strcat(), strlen() */
#include <stdlib.h>    /* for malloc(), free(), exit() */

int main() {
    char s1[10]="ABCD", s2[10]="abcd"; /* declare strings */
    char *s;                           /* string needs memory */

    /* Allocate memory for string s to hold s1, s2, and '\0' */
       NOTE: add 1 byte for the null terminating character '\0' !!! */
    s = (char *)malloc(sizeof(char)*(strlen(s1)+strlen(s2)+1));
    if(s==NULL) {
        printf("Error: no memory\n");
        exit (EXIT_FAILURE);
     }
     strcpy(s, s1);          /* copy string s1 to s */
     printf("s = %s\n", s);  /* print string s */
     strcat(s, s2);          /* append string s2 to string s */
     printf("s = %s\n", s);  /* print string s again */
     printf("strlen(s1) = %d\n", strlen(s1)); /* calculate strlen for s1 */
     printf("strlen(s) = %d\n", strlen(s));   /* calculate strlen for s2 */
     free(s);                /* free the allocated memory for s */
     return 0;
}
