/* File: accel.h
   Header file for calculating and plotting accelerations 
   using a structure */
#ifndef ACCEL_H
#define ACCEL_H

#define M_G   9.81  /* gravitational acceleration constant g */
#define N     100   /* num of points for plotting */

struct Body {      /* structure for a body */
      double mu;   /* friction coefficient */
      double m;    /* mass */
};

/* function prototypes */
extern double force(double t);
extern double accel(const struct Body *b, double t);
extern void plotAccel(const struct Body *b, double t0, double tf);

#endif 
