/* File: alignment.c
   Demonstrate alignment of structures */
#include <stdio.h>
#include <stddef.h> /* for macro offsetof() */ 

struct tag1 {       /* 1st structure with int, short, double */
    int i;
    short s;
    double d;
};
struct tag2 {       /* 2nd structure with int, double, short */
    int i;
    double d;
    short s;
};

int main() {
    size_t offset; /* offset for members of a structure *.

    /* obtain the size and offsets for members of 1st structure */
    printf("sizeof(struct tag1) = %u\n", sizeof(struct tag1));
    offset = offsetof(struct tag1, i);
    printf("offset i in struct tag1 = %u\n", offset);
    offset = offsetof(struct tag1, s);
    printf("offset s in struct tag1 = %u\n", offset);
    offset = offsetof(struct tag1, d);
    printf("offset d in struct tag1 = %u\n\n", offset);

    /* obtain the size and offsets for members of 2nd structure */
    printf("sizeof(struct tag2) = %u\n", sizeof(struct tag2));
    offset = offsetof(struct tag2, i);
    printf("offset i in struct tag2 = %u\n", offset);
    offset = offsetof(struct tag2, d);
    printf("offset d in struct tag2 = %u\n", offset);
    offset = offsetof(struct tag2, s);
    printf("offset s in struct tag2 = %u\n", offset);
    return 0;
}
