/* File: dynmemory.c
   Dynamically allocate memory for a structure */
#include <stdio.h>
#include <string.h>        /* for strcpy() */
#include <stdlib.h>        /* for malloc() and free() */

struct Student {
    int id;
    char name[32];  
};

struct Student *func(int id, char *name) {
    struct Student *sp; /* local variable sp is diff from sp in main() */
    /* allocate the memory for sp */
    sp = (struct Student *)malloc(sizeof(struct Student));
    sp->id = id;             /* fill the first 4 bytes with id */
    strcpy(sp->name, name);  /* fill the subsequent ones with name */
    return sp;  /* return dynamically allocated memory for structure */
}

int main() {
    struct Student *sp;

    sp = func(101, "John"); /* sp pointer to dynamically allocated memory */
    printf("sp->id = %d\n", sp->id);
    printf("sp->name = %s\n", sp->name);
    free(sp);               /* free the allocated memory */
    return 0;
}
