/* File: funcstructargarray.c
   pass an array of structures to a function */
#include <stdio.h>

#define EOD -1      /* define a sentinel number for end of data */

struct Student {
    int id;
    char name[32];  
    double gpa;
};

void func1(int n, struct Student s[]) { /* argument as an array */
    int i;
  
    for(i=0; i<n; i++) {   /* treat s as an array */
       printf("id = %d ", s[i].id);
       printf("name = %5s ", s[i].name);
       printf("GPA = %.2f\n", s[i].gpa);
    }
    while(s->id != EOD) {  /* treat s as a pointer */
       printf("id = %d ", s->id);
       printf("name = %5s ", s->name);
       printf("GPA = %.2f\n", s->gpa);
       s++;
    }
}
    
void func2(int n, struct Student *sp) { /* argument as a pointer */
    int i;
  
    for(i=0; i<n; i++) {   /* treat sp as an array */
       printf("id = %d ", sp[i].id);
       printf("name = %5s ", sp[i].name);
       printf("GPA = %.2f\n", sp[i].gpa);
    }
    while(sp->id != EOD) {  /* treat sp as a pointer */
       printf("id = %d ", sp->id);
       printf("name = %5s ", sp->name);
       printf("GPA = %.2f\n", sp->gpa);
       sp++;
    }
}

/* calculate average GPA's for all students */
double averageGPA(struct Student *sp) {
    double gpa, totalval;
    int i;

    totalval=0.0; /* initialize the totalval */
    for(i=0; sp[i].id != EOD; i++) {
         totalval += sp[i].gpa;  /* add a GPA to totalval */
    }
    gpa = totalval/(double)i;    /* calculate GPA */
    return gpa;                  /* return the GPA */
}

int main() {
    struct Student s[] = {{101, "John",  3.33}, 
                          {102, "Doe",   3}, 
                          {103, "Peter", 3.1},
                          {EOD, NULL, EOD}}; /* terminating element */
    struct Student *sp;   /* pointer to structure */

    sp = s;               /* sp pointer to s */
    func1(3, s);          /* pass s to func1() */
    func1(3, sp);         /* pass sp to func1() */
    func2(3, s);          /* pass s to func2() */
    func2(3, sp);         /* pass sp to func2() */
    printf("GPA for students in the list is %.2f\n", averageGPA(s));
    return 0;
}
