/* File: memberptr.c
   Structure with member of pointer type */
#include <stdio.h>
#include <string.h>    /* for strcpy() */
#include <stdlib.h>    /* for malloc(), free(), exit() */

struct Student {
    int id;
    char *name;        /* name is a pointer to char */
};

int main() {
    struct Student s;

    s.id = 101;
    /* allocate memory for the member 'name' */
    s.name = (char *)malloc(sizeof(char)*(strlen("John")+1));
    if(s.name == NULL) {
      printf("Error: no memory\n");
      exit(EXIT_FAILURE);
    }
    strcpy(s.name, "John"); /* use the allocated memory */

    printf("s.id   = %d\n", s.id);
    printf("s.name = %s\n", s.name);
    free(s.name);           /* free the allocated memory */
    return 0;
}
