/* File: nestedpointer.c
   Use a nested pointer to structure */
#include <stdio.h>
#include <string.h>            /* for strcpy() */

struct Birthday {              /* define struct Birthday */
    short day, month, year;
};

struct Staff {                 /* define struct Staff */
    int id;
    char name[32];
    struct Birthday *birthday; /* contain a nested pointer to structure */
};

int main() {
    struct Staff s;            /* declare variable of struct Staff */
    struct Birthday bday;      /* declare variable of struct Birthday */ 

    /* set s for John */
    s.id = 101;
    strcpy(s.name, "John");
    s.birthday = &bday;       /* s.birthday points to bday */
    /* set John's birthday */
    s.birthday->day = 16;     
    s.birthday->month = 8;
    s.birthday->year = 1990;

    /* print the information for John in s */
    printf("id   = %d\n", s.id);
    printf("name = %s\n", s.name);
    printf("birthday = %d\n", s.birthday->day);
    printf("birth month = %d\n", s.birthday->month);
    printf("birth year = %d\n", s.birthday->year);
    return 0;
}
