/* File: nestedpointer2.c
   Use a nested pointer to structure with dynamically allocation
   for the memory */
#include <stdio.h>
#include <string.h>            /* for strcpy() */

struct Birthday {              /* define struct Birthday */
    short day, month, year;
};

struct Staff {                 /* define struct Staff */
    int id;
    char name[32];
    struct Birthday *birthday; /* contain a nested pointer to structure */
};

int main() {
    struct Staff *sp;          /* declare a pointer to struct Staff */
    struct Birthday *bday;     /* declare a pointer to struct Birthday */ 

    
    /* allocated memory for John */ 
    sp = (struct Staff *)malloc(sizeof(struct Staff));
    sp->id = 101;               /* set John's id */
    strcpy(sp->name, "John");   /* set John's name */
    /* allocate memory for holding John's birthday */
    bday = (struct Birthday*)malloc(sizeof(struct Birthday));
    /* set John's birthday */
    bday->day = 16;
    bday->month = 8; 
    bday->year = 1990;    
    sp->birthday = bday;

    /* print the information for John in sp */
    printf("id   = %d\n", sp->id);
    printf("name = %s\n", sp->name);
    printf("birthday = %d\n", sp->birthday->day);
    printf("birth month = %d\n", sp->birthday->month);
    printf("birth year = %d\n", sp->birthday->year);
    /* free allocated memory, you must free sp->birthday first, 
    before free sp. However, memory birthday can also be freed by free(bday) */
    free(sp->birthday); /* or free(bday); */
    free(sp);
    return 0;
}
