/* File: time.c
   Use time functions with structure tm */
#include <stdio.h>
#include <time.h> /* for time_t, struct tm, and time functions */

/* define an array of pointers for names of each day */
const char *wday[] = { 
      "Sunday", "Monday", "Tuesday", "Wednesday",
      "Thursday", "Friday", "Saturday", "-unknown-"
};

int main() {
    time_t timer;            /* declare timer */
    struct tm *timeptr, ts;  /* declare timeptr and ts of structure type */
    char *timestr;           /* time string */

    timer = time(NULL);      /*  get the current calendar time */
    printf("timer = %d\n", timer); /* print it */ 

    timeptr = localtime(&timer);   /* convert calendar time to local time */
    /* print local time in broken-down time */
    printf("year = %d\n", timeptr->tm_year+1900);
    printf("month = %d\n", timeptr->tm_mon+1);
    printf("day = %d\n", timeptr->tm_mday);
    printf("wday = %d\n", timeptr->tm_wday);
    /* use wday[] to convert an integer into a string for a day */
    printf("wday = %s\n", wday[timeptr->tm_wday]);
    printf("hour = %d\n", timeptr->tm_hour);
    printf("minute = %d\n", timeptr->tm_min);
    printf("second = %d\n", timeptr->tm_sec);
    printf("Daylight Saving Time flag = %d\n", timeptr->tm_isdst);

   /* convert the broken-down time into a time string */
    timestr = asctime(timeptr);   
    printf("time = %s", timestr); /* print time string */
   /* convert the calendar time into a time string */
    timestr = ctime(&timer);
    printf("time = %s", timestr); /* print time string */

    /* obtain one year from the current time in the broken-down time */
    timeptr->tm_year += 1;        
    /* conver in the broken-down time into the calendar time */
    timer = mktime(timeptr);
    printf("timer = %d\n", timer);  /* print the calendar time */
    return 0;
}
