/* File: union1.c 
   Demonstrate the concept of the union */
#include <stdio.h>
#include <stddef.h>  /* for offsetof() */

union data {      /* define a union */ 
    int i;        /* a member of int type */
    double d;     /* a member of double type */
};

int main() {
    union data u; /* declare variable u of union type */

    /* the size of union is the memory for the largest member, double */
    printf("sizeof(union data) = %u\n", sizeof(union data));
    printf("sizeof(u) = %u\n", sizeof(u));
    /* the offset for each member of the union is the same, 0 */ 
    printf("offsetof(union data, i) = %u\n", offsetof(union data, i));
    printf("offsetof(union data, d) = %u\n", offsetof(union data, d));

    /* assign the member i with an integer, use 4 bytes */
    u.i = 10; 
    printf("u.i = %d\n", u.i);    /* u.i is 10 */
    printf("u.d = %f\n", u.d);    /* u.d is undefined */ 
    /* assign the member d with a floating point number, use 8 bytes */
    u.d = 20.0;
    printf("u.i = %d\n", u.i);    /* u.i is undefined */
    printf("u.d = %f\n", u.d);    /* u.d is 20.0 */ 
    return 0;
}
