/* File: accelbini.c
   Read the binary file accel.bin written by program accelbino.c */
#include <stdio.h>  /* for fopen(), fclose(), fread(), fseek(), printf() */
#include <stdlib.h> /* for exit() */
#define N     11    /* number of elements for array a */

int main() {
    double a[N];    /* declare an array for accelerations */
    double d;       /* one element of array for accelerations */
    int i;          /* index variable */
    FILE *stream;   /* a file stream for reading */

    /* open binary file accel.bin */
    stream = fopen("accel.bin", "rb"); 
    if(stream == NULL) {
      printf("Error: cannot open 'accel.bin'\n");
      exit(EXIT_FAILURE);
    }
    /* read N numbers of double type in binary mode */
    fread(a, sizeof(double), N, stream);
    printf("Data from file accel.bin.\n");
    for(i=0; i<N; i++) {
      printf("a[%d] = %f\n", i, a[i]);
    }
   
    /* reset file stream to the 5th element */
    fseek(stream, 4*sizeof(double), SEEK_SET);
    /* read the 5th element */
    fread(&d, sizeof(double), 1, stream);
    printf("The 5th element of acceleration is %f\n", d);
    /* read the next in the file pointed by stream, 6th element */
    fread(&d, sizeof(double), 1, stream);
    printf("The 6th acceleration is %f\n", d);
    fclose(stream); /* close the file stream */
    return 0;
}
