/* File: accelo.c 
   Write accelerations into file accel.txt */
#include <stdio.h>  /* for fopen(), fclose(), fprintf(), printf() */
#include <stdlib.h> /* for exit() */
#define M_G   9.81  /* gravitational acceleration constant g */

int main() {
    /* declaration and initialization */
    double a, mu=0.2, m=5.0, t0=0.0, tf=10.0, step=1.0, p, t;
    int i, n;      
    FILE *stream;  /* a file stream */

    /* open file accel.txt for writing */
    stream = fopen("accel.txt", "w"); 
    if(stream == NULL) {
      printf("Error: cannot open 'accel.txt'\n");
      exit(EXIT_FAILURE);
    }
    n = (tf - t0)/step + 1;       /* number of points, 11 */
    for(i=0; i<n; i++) {
       t = t0 + i*step;           /* calculate value t */
       p = 4*sin(t-3)+20;         /* use t to calculate p */
       a = (p-mu*m*M_G)/m;        /* calculate a */
       fprintf(stream, "%f\n", a);/* write acceleration into the file */
    }
    fclose(stream);               /* close the file stream */
    printf("Done! Finished writing data to file accel.txt\n");
    return 0;
}
