/* File: accelvarout.c 
   Calculate the acceleration using variables.
   Redirect output from stdout to accelvar.out.
   The program is modified based on accelvar.c  */
#include <stdio.h>  /* for printf(), FILE,  freopen(), fclose() */
#include <stdlib.h> /* for exit() */

int main() {
    /* declare variables */
    double a,     /* acceleration */
           mu,    /* friction coefficient */
           m,     /* mass */
           p;     /* external force */
    FILE *stream; /* declare a file stream */

    /* redirect stdout to accelvar.out */
    stream = freopen("accelvar.out", "w", stdout);
    if(stream ==  NULL) { /* open "accelvar.out" failed */
        printf("Error: cannot open 'accelvar.out'\n");
        exit(EXIT_FAILURE);
    }

    /* initialize variables */
    mu = 0.2;
    m = 5.0;
    p = 20.0;

    /* calculate the acceleration */
    a = (p-mu*m*9.81)/m;

    /* the stdout is directed to file "accelvar.out" */
    printf("Acceleration a = %f (m/s^2)\n", a);
    fclose(stream); /* close the file stream */
    return 0;
}
