/* File: copyfile.c
   Copy a file character by character */
#include <stdio.h> /* for fopen(), fclose(), fgetc(), fputc(), feof() */

int copyfile(const char *inputfile, const char *outputfile) {
    FILE *fp1, *fp2; /* declare FILE pointers for input and output files */
    char c;          /* the buffer for a character */

    /* Treat file as a binary file. */
    /* open the input file for reading */ 
    if((fp1 = fopen(inputfile, "rb")) == NULL) 
        return -1; /* if failed to open the file for reading, return -1  */
    /* open the output file for writing */ 
    if((fp2 = fopen(outputfile, "wb")) == NULL) {
        fclose(fp1); /* close the opened file for reading */
        return -1; /* if failed to open the file for writing, return -1 */
    }
    c  = fgetc(fp1);     /* read a character */
    while(!feof(fp1)) {  /* while not end-of-file */
       fputc(c, fp2);    /* write a character to the output file */
       c  = fgetc(fp1);  /* read a new character from the input file */
    }
    fclose(fp1);         /* close the file stream for the input file */
    fclose(fp2);         /* close the file stream for the output file */
    return 0;
}
