/* File: readdir.c
   Read the contents in the current directory */
#include <dirent.h>     /* for DIR, struct dirent, 
                           opendir(), readdir(), closedir() */
#include <sys/stat.h>   /* for struct stat, stat() */

int main() {
    struct stat stbuf;   /* declare a variable of a stat structure */
    DIR *dirp;           /* declare dirp of DIR type, a directory stream */  
    struct dirent *direntp;    /* directory entry */
    const char *dirname = "."; /* the current directory */

    /* check if dirname is a searchable directory */
    if(!stat(dirname, &stbuf) && S_ISDIR(stbuf.st_mode)) {
        dirp = opendir(dirname);  /* open a directory stream */
    }

    printf("List of files/dirs in directory %s :\n", dirname);
    while(direntp = readdir(dirp)) {     /* read one entry at a time */
        printf("%s\n", direntp->d_name); /* list file or directory */
    }
    closedir(dirp);               /* close the directory stream */
    return 0;
}
