/* File: rename.c
   rename and remove file 'accel.txt' created by program accelo.c */
#ifdef _WIN32           /* if compiled using Visual Studio .NET */
#define F_OK    0       /* define F_OK for existence of File */
#define X_OK    1       /* define X_OK for eXecute permission */
#define W_OK    2       /* define W_OK for Write permission */
#define R_OK    4       /* define R_OK for Read permission */
#include <io.h>         /* for access() */
#else                   /* all other platforms */
#include <unistd.h>     /* for X_OK, F_OK, R_OK, W_OK and access() */
#endif
#include <stdlib.h>     /* for exit() */

int main() {
    const char *name = "accel.txt";   /* a file name */
    int status;                       /* return value of functions */

    if(!access(name, F_OK)) {         /* check if file exists */
        if(!access(name, W_OK)) {     /* check if file is writable */
           /* rename file "accel.txt" as file "myaccel.txt" */
           status = rename(name, "myaccel.txt"); 
           if(!status) {   /* check the status of rename() function call */
              printf("accel.txt renamed as myaccel.txt\n");
              status = remove("myaccel.txt"); /* remove file myaccel.txt */
              if(!status) { /* check the status of remove() function call */
                printf("myaccel.txt removed\n");
              }
              else {
                printf("myaccel.txt cannot be removed\n");
              }
           }
           else {
              printf("accel.txt cannot be renamed as myaccel.txt\n");
           }
        }
        else {
           printf("accel.txt is not writable, no permission to rename\n");
           exit(EXIT_FAILURE);
        }
    }
    else {
        printf("accel.txt does not exist\n");
        exit(EXIT_FAILURE);
    }
    exit(EXIT_SUCCESS);
}
