/* File: rewinddir.c
   rewind a directory */
#include <dirent.h>     /* for DIR, struct dirent, 
                           opendir(), readdir(), closedir(), rewinddir() */
#include <sys/stat.h>   /* for struct stat, stat() */

int main() {
    struct stat stbuf;   /* declare a variable of a stat structure */
    DIR *dirp;           /* declare dirp of DIR type, a directory stream */  
    struct dirent *direntp;    /* directory entry */
    const char *dirname = "."; /* the current directory */
    int i;                     /* index variable */

    /* check if dirname is a searchable directory */
    if(!stat(dirname, &stbuf) && S_ISDIR(stbuf.st_mode)) {
        dirp = opendir(dirname);  /* open a directory stream */
    }

    /* print the first four entries in the current directory */
    printf("The first four entries in directory %s are :\n", dirname);
    for(i = 0; i < 4; i++) {
        direntp = readdir( dirp );
        printf( "%s\n", direntp->d_name );
    }

    /* reset the position of the directory stream to which
       dirp refers to the beginning of the directory. */
    rewinddir(dirp); 

    printf("\nAfter calling function rewinddir(), files in "
           "directory %s are :\n", dirname);
    while(direntp = readdir(dirp)) {     /* read one entry at a time */
        printf("%s\n", direntp->d_name); /* list file or directory */
    }
    closedir(dirp);               /* close the directory stream */
    return 0;
}
