/* File: strerror.c
   Handling error messages  */
#include <stdio.h>    /* for fopen() and perror() */
#include <string.h>   /* for strerror() */
#include <errno.h>    /* for errno */
#include <stdlib.h>   /* for exit() */

int main() {
    FILE *fp;              /* declare a file pointer */
    char *errmessage;      /* pointer to error message */
   
    fp = fopen("UnknownFile", "r");  /* a failed statement */
    if(fp==NULL) {   /* cannot open the file by fopen() */
        /* get the error message based on errno */
        errmessage = strerror(errno); 
        printf("fopen(): %s\n", errmessage); 
        /* Altenratively, use perror("fopen()"); */
        exit(EXIT_FAILURE);
    }
    exit(EXIT_SUCCESS);
}
