/* File: studentfile.h for using an array of struct Student */
#ifndef STUDENTFILE_H
#define STUDENTFILE_H

/* define boolean numbers */
#define TRUE 1
#define FALSE 0

struct Birthday {
    short day, month, year;
};

typedef struct Student {
    int id;
    char name[32];  
    struct Birthday birthday;
    double gpa;
} student_t;

/* functions for a single student */
extern void gpa_printStudent(const student_t *sp);
extern int gpa_getId(const student_t *sp);
extern char *gpa_getName(const student_t *sp);
extern struct Birthday gpa_getBirthday(const student_t *sp);
extern double gpa_getGPA(const student_t *sp);
extern void gpa_setGPA(student_t *sp, double gpa);

/* functions for a list of students */
extern int gpa_totnum(const student_t *head);
extern void gpa_printList(const student_t *head);
extern double gpa_averageGPA(const student_t *head);
extern student_t *gpa_highestGPA(const student_t *head);
extern student_t *gpa_lowestGPA(const student_t *head);
extern student_t *gpa_find(const student_t *head, int id, const char *name);
extern int gpa_aboveGPA(const student_t *head, double gpa);
extern void gpa_sortGPA(student_t *head);
extern student_t *gpa_readData(const char *filename);
extern int gpa_writeData(const student_t *head, const char *filename);
extern void gpa_clearList(student_t *head);

/* utility functions */
extern const char *gpa_monthString(int month);

/* load code from file studentfilefunc.c for Ch */
#ifdef _CH_
#pragma importf "studentfilefunc.c"
#endif

#endif /* STUDENTFILE_H */
