/* File: dlist.c 
   Create and manipulate a doubly linked list */
#include <stdio.h>
#include "dlist.h"   /* header file for doubly linked list */

int main() {
    Node head, nd, node;  /* head and nodes of the list */
    /* create four nodes of a list */
    Node nd1 = createNode(101, "John"),
         nd2 = createNode(102, "Doe"),
         nd3 = createNode(103, "Peter"),
         nd4 = createNode(104, "Mary");

    head = NULL;          /* initialize head of the list */
    prepend(&head, nd1);  /* prepend node nd1 to head of the list */
    prepend(&head, nd2);  /* prepend node nd2 to the head of the list */
    append(&head, nd3);   /* append node nd3 to the list */
    insert(&head, nd4, 2);/* insert node nd4 at 2nd place of the list */
    printf("A doubly linked list:\n");
    printList(head);     /* print the list */

    /* find node with id 104 and name Mary */
    node = find(head, 104, "Mary");
    nd = node;        /* save node */
    printf("Travel list forward starting with node for Mary:\n");
    while(nd != NULL) {
      print(nd);
      nd = nd->next;
    }
    nd = node;        /* set nd to node */
    printf("Travel list backbard starting with node for Mary:\n");
    while(nd != NULL) {
      print(nd);
      nd = nd->prev;
    }

    nd = find(head, 101, "John");/* find node with id 101 and name John */
    remov(&head, nd);     /* remove this node from the list */
    printf("List without node for John:\n");
    printList(head);     /* print the list */
    clearList(head);     /* clear the list */
    return 0;
}
