/* File: list.h 
   header file for singly linked list */
#ifndef LIST_H_
#define LIST_H_

/* a self-referencing structure for a list node */
struct ListNode {
    int id;                /* id number */
    char *name;            /* name */
    struct ListNode *next; /* link to the next node */
};
typedef struct ListNode *Node; /* define type Node */

/* function prototypes for list processing */
/* create a node */
extern Node createNode(int id, const char *name);
/* free an elment */
extern void freeNode(Node nd);
/* prepend to the list at the beginning */
extern void prepend(Node *head, Node nd);
/* append to the list at end */
extern void append(Node *head, Node nd);
/* insert to the list at pos */
extern int insert(Node *head, Node nd, int pos);
/* find the node with id and name */
extern Node find(Node head, int id, const char *name);
/* remove a node from the list */
extern void remov(Node *head, Node nd);
/* print id and name in a node */
extern void print(Node nd);
/* print id and name in each node of the list */
extern void printList(Node head);
/* clear all nodes attached to the list */
extern void clearList(Node head);

/* import definitions of list processing functions for Ch */ 
#ifdef _CH_
#pragma importf <listlib.c>
#endif

#endif /* LIST_H_ */
