/* File: selfref.c
   Use a self-referencing structure */
#include <stdio.h>
#include <stdlib.h>  /* for malloc() and free() */

struct Teacher {
    int id;
    char name[32];  
    struct Teacher *next;  /* link to the next node */
};

struct Teacher *addTeacher(int id, char *name) {
    struct Teacher *tp;
    tp = (struct Teacher *)malloc(sizeof(struct Teacher));
    tp->id = id;            /* set member id */
    strcpy(tp->name, name); /* set member name */
    tp->next = NULL;        /* set member next, point to NULL */
    return tp;
}

int main() {
    struct Teacher *head;

    head = addTeacher(101, "John");      /* first node */
    head->next = addTeacher(102, "Doe"); /* link two nodes */ 

    printf("id = %d\n", head->id);       /* print 1st node */
    printf("name = %s\n", head->name);
    printf("id = %d\n", head->next->id); /* print 2nd node */
    printf("name = %s\n", head->next->name);
    free(head->next);                    /* free 2nd node */
    free(head);                          /* free 1st node */
    return 0;
}
