/* File: selfrefloop.c
   Use while-loops to process nodes of 
   self-referencing structure in a linked list */
#include <stdio.h>
#include <stdlib.h>  /* for malloc() and free() */

struct Teacher {
    int id;
    char name[32];  
    struct Teacher *next;  /* link to the next node */
};

struct Teacher *addTeacher(int id, char *name) {
    struct Teacher *tp;
    tp = (struct Teacher *)malloc(sizeof(struct Teacher));
    tp->id = id;            /* set member id */
    strcpy(tp->name, name); /* set member name */
    tp->next = NULL;        /* set member next, point to NULL */
    return tp;
}

int main() {
    struct Teacher *head, *node;

    head = addTeacher(101, "John");
    head->next = addTeacher(102, "Doe");

    node = head;  /* point to the head */
    while(node != NULL) {  /* process all nodes */
      printf("id = %d\n", node->id);
      printf("name = %s\n", node->name);
      node = node->next;
    }

    while(head != NULL) {   /* remove memory for each node */
      node = head;          /* node points to the head */
      head = node->next;    /* head points to the next node */
      free(node);           /* free the previous head through node */
    }
    return 0;
}
