/* File: fltmax.c (run in C99 and Ch only)
   Compile in gcc, use command 'gcc -std=c99 fltmax.c -lm' 
   Calculate the floating-point constants FLT_MAX, FLT_MAX_10_EXP,
   FLT_MAX_EXP defined in header file float.h  */
#include <stdio.h>
#include <tgmath.h>      /* for INFINITY, pow(), frexp() */

int main() {
    float base=10.0, /* base 10 for exponential value */
          flt_max,   /* for calculating and holding FLT_MAX */
          f;         /* a temporary variable with float type  */
    int e,           /* for calculating and holding FLT_MAX_10_EXP */
        flt_max_exp, /* FLT_MAX_EXP */
        i;           /* index variable */

    /* calculate exponential number FLT_MAX_10_EXP, '38'in 3.40282347e+38 */
    e = 0;     /* initialize e */
    f = base;  /* initialize f */
    while(f != INFINITY) { /* looping until f == Inf */
      e++;                 /* increment e */
      f *= base;           /* 10^e */
    }
    /* e contains the value for FLT_MAX_10_EXP */
    printf("FLT_MAX_10_EXP = %d \n", e);

    /* calculate FLT_MAX */
    /* step 1, calculate leading non-zero number, '3'in 3.40282347e+38 
       at the end of the loop, i becomes 4 */
    i = 0; f = 0.0; /* intialize variables */ 
    while(f != INFINITY)
      f = ++i * pow(base, e);

    /* step 2, calculate numbers after decimal point, 
       40282347 in '3.40282347e+38' */
    flt_max = i;   /* flt_max is 4 to start with */
    while(e != 0)  /* use a loop to calculate FLT_MAX */
    {
      /* 1st iteration, flt_max is 4.0, after this statement, flt_max is 30 */
      /* 2nd iteration, flt_max is 35.0, after this statement,flt_max is 34.0 */
      flt_max = --flt_max * base; 
      /* obtain the remaining value */
      e--; i = 0; f = 0.0;
      while(f != INFINITY && i < 10)
      {
        f = ++flt_max * pow(base, e);
        i++;
      }
    }
    printf("FLT_MAX = %.8e \n", flt_max);

    /* calculate FLT_MAX_EXP */
    f = frexp(flt_max, &flt_max_exp);       
    printf("FLT_MAX_EXP = %d \n", flt_max_exp);
    return 0;
}
