/* File: cgeneric.c  (run in C99 and Ch only)
   Compile in gcc, use command 'gcc -std=c99 cgeneric.c -lm'
   Use generic mathematical functions for complex argument */
#include <stdio.h>
#include <complex.h>   /* for complex, I, creal(), cimag() */
#include <tgmath.h>    /* sin() */

int main() {
    /* declare and initialize  complex variables z and dz */
    complex z = 1.0+I*2.0;          
    double complex dz = 1.0+I*2.0;

    /* calculate and print sin() for z and dz */
    z = sin(z);
    dz = sin(dz);
    printf("z  = complex(%f, %f)\n", creal(z), cimag(z));
    printf("dz = complex(%f, %f)\n", creal(dz), cimag(dz));
    return 0;
}
