/* File: quadratic2.c  (run in C99 and Ch only)
   Compile in gcc, use command 'gcc -std=c99 quadratic2.c -lm'
   Solve for two complex roots of the quadratic equation
   x^2-4x+13 = 0  in the complex domain */
#include <stdio.h>
#include <tgmath.h>   /* for sqrt() */
#include <complex.h>  /* for complex, I, creal(), cimag() */


int main() {
    /* declare variables of type complex for the coefficients
       of the quadratic equation and roots;
       initialize the coefficients */
    double complex a = 1.0, b = -4.0, c = 13.0, x1, x2;

    /* solve for two roots of the quadratic equation */
    x1 = (-b+sqrt(b*b-4*a*c))/(2*a);  /* first branch */
    x2 = (-b-sqrt(b*b-4*a*c))/(2*a);  /* second branch */

    /* display two roots */
    printf("x1 = complex(%f, %f)\n", creal(x1), cimag(x1));
    printf("x2 = complex(%f, %f)\n", creal(x2), cimag(x2));
    return 0;
}
