/* File: accel.h
   header file for calculate the acceleration using class  */
#ifndef ACCEL_H
#define ACCEL_H

#define M_G   9.81  // gravitational acceleration constant g 
#define N     100   // num of points for plotting

class CBody {       // define class CBody
    public:    // public member functions
      CBody();       // constructor 
      ~CBody();      // destructor
      void setSys(double mu, double m);  // member function to set system
      double force(double t);            // member function for force 
      double accel(double t);            // member function for accel
      void plotAccel(double t0, double tf);// member function for plotting
    private:  // private data
      double m_mu;  // friction coefficient
      double m_m;   // mass
};

/* load member function definitions in file CBody.cpp for Ch */
#ifdef _CH_
#pragma importf <CBody.cpp>
#endif 

#endif 
