/* File: accelclass.cpp
   Use class CBody to calculate and plot accelerations */
#include <iostream>        // for I/O in C++
#include "accel.h"         // for class CPlot and member functions 
using namespace std;       // for using cout, cin, cerr, endl


int main() {
    /* declare accel, force, time, initial time, final time, mu, mass */
    double a, p, t, t0, tf, mu, m;
    CBody b;            /* CBody b = CBody(); */

    mu = 0.2;           /* mu */
    m = 5.0;            /* mass */
    t = 2.0;            /* set time at 2 seconds */
    t0 = 0.0;          /* initial time 0 second */
    tf = 10.0;         /* final time 10 seconds */
    b.setSys(mu, m);    /* set system */
    p = b.force(t);     /* calculate force */
    a = b.accel(t);     /* calculate acceleration */
    /* display force p and acceleration a, and plot accelerations */
    cout << "External force p = " << p << " (N)" << endl;
    cout << "Acceleration a = " << a << " (m/s^2)" << endl;
    b.plotAccel(t0, tf); /* plot accelerations by passing address of b */
    return 0;
}

