/* File: membercout.cpp
   Use member functions and cout */
#include <string.h>        // for strcpy()
#include <iostream>        // for I/O in C++ 
using namespace std;       // for using cout, cin, cerr, endl 

class CStudent{            // define class CStudent
    public:                // declare public member functions            
      void setId(int id);
      void setName(char *name);
      void print();
      void freeMemory();
    private:               // declare private data
      int m_id;
      char *m_name;
};

void CStudent::setId(int id) {            // set student ID 
    m_id = id;
}

void CStudent::setName(char *name) {      // set student name
    if(name != NULL) {
      m_name = new char[strlen(name)+1];  // allocate memory for name
      strcpy(m_name, name);
    }
}

void CStudent::print() {                  // print student info
    cout << "m_id   = " << m_id <<endl;
    cout << "m_name = " << m_name <<endl;
}

void CStudent::freeMemory() {// free the allocated memory by CStudent::setName()
    if(m_name != NULL)
       delete(m_name);
}

int main() {
    CStudent s;        // instantiate an instance of class CStudent;

    s.setId(101);      // set student ID
    s.setName("John"); // allocate memory and set student name
    s.print();         // print student ID and name
    s.freeMemory();    // free the allocated memory for m_name
    return 0;
}
