/* File: axisrangeplotxy.ch */
#include <math.h>    
#include <chplot.h>

int main() {
  int numpoints = 36;
  array double x1[numpoints], y1[numpoints];
  array double x2[numpoints], y2[numpoints];
  char *title="Sine and Cosine Waves",        
       *xlabel="degree",
       *ylabel="amplitude";
  CPlot plot;

  lindata(0, 360, x1);
  lindata(0, 360, x2);
  y1 = sin(x1*M_PI/180);
  y2 = cos(x2*M_PI/180);
  plotxy(x1, y1, numpoints, title, xlabel, ylabel, &plot);    
  plot.data2DCurve(x2, y2, numpoints);   
  plot.legend("sin(x)", 0);
  plot.legend("cos(x)", 1);  
  plot.legendLocation(75, -0.5);
  plot.axisRange(PLOT_AXIS_X, 0.0, 360.0);       // set axis range
  plot.ticsRange(PLOT_AXIS_X, 30.0, 0.0, 360.0); // set tics marks
  plot.axisRange(PLOT_AXIS_Y, -1.0, 1.0);        // set axis range
  plot.ticsRange(PLOT_AXIS_Y, 0.25, -1, 1);      // set tics marks
  plot.plotting();          
  return 0;
}
