/* File: legend.ch */
#include <math.h>    
#include <chplot.h>

int main() {
    int numpoints = 36;
    array double x1[numpoints], y1[numpoints];
    array double x2[numpoints], y2[numpoints];
    CPlot plot;

    lindata(0, 360, x1);
    lindata(0, 360, x2);
    y1 = sin(x1*M_PI/180);
    y2 = cos(x2*M_PI/180);
    plot.data2DCurve(x1, y1, numpoints);    
    plot.data2DCurve(x2, y2, numpoints);   
    plot.legend("sin(x)", 0);
    plot.legend("cos(x)", 1);  
    plot.legendLocation(75, -0.5);    // set the location for legends
    plot.title("Sine and Cosine Waves");
    plot.label(PLOT_AXIS_X, "degree");
    plot.label(PLOT_AXIS_Y, "amplitude");
    plot.axisRange(PLOT_AXIS_X, 0.0, 360.0);       // set axis range
    plot.ticsRange(PLOT_AXIS_X, 30.0, 0.0, 360.0); // set tics marks
    plot.axisRange(PLOT_AXIS_Y, -1.0, 1.0);        // set axis range
    plot.ticsRange(PLOT_AXIS_Y, 0.25, -1, 1);      // set tics marks
    plot.plotting();          
    return 0;
}
