/* File: plotclass.cpp 
   Plot sin(x) from 0 to 2PI using class CPlot */
#include <math.h>   // for sin() and M_PI
#include <chplot.h> // for CPlot

#define N 37        // number of points for plotting

int main() {
    double x[N], y[N], x0, xf;
    char title[] = "function sin(x)",
         xlabel[] = "x",
         ylabel[] = "sin(x)";
    int i;
    CPlot plot;

    x0 = 0;
    xf = 2*M_PI;
    for(i=0; i<N; i++)  {
        x[i] = x0 + i*(xf - x0)/(N-1); 
        y[i] = sin(x[i]);
    }
    /* use member functions of class CPlot */
    plot.title(title);
    plot.label(PLOT_AXIS_X, xlabel);
    plot.label(PLOT_AXIS_Y, ylabel);
    plot.data2DCurve(x, y, N);
    plot.plotting();
    return 0;
}
