/* File: posvelaccel.cpp
   Plot position, velocity, and acceleration in subplots in the same figure */
#include <math.h>
#include <chplot.h>

double position(double t) {     // function for position
    return 2*t*t*t - 24*t + 6;
}

double velocity(double t) {     // function for velocity 
    return 6*t*t - 24;
}

double accel(double t) {        // function for acceleration
    return 12*t;
}

int main() {
    double t0 = 0, tf = 4;
    int num = 100;
    CPlot subplot, *plot;

    subplot.subplot(3, 1);      // create 3x1 subplots
    subplot.enhanceText();      // using enhanced text 
    /* subplot for position */
    plot = subplot.getSubplot(0, 0); 
    plot->label(PLOT_AXIS_X, "time (s)");
    plot->label(PLOT_AXIS_Y, "position (m)");
    plot->func2D(t0, tf, num, position);
    plot->ticsRange(PLOT_AXIS_Y, 10);

    /* subplot for velocity */
    plot = subplot.getSubplot(1, 0); 
    plot->label(PLOT_AXIS_X, "time (s)");
    plot->label(PLOT_AXIS_Y, "velocity (m/s)");
    plot->func2D(t0, tf, num, velocity);
    plot->ticsRange(PLOT_AXIS_Y, 20);

    /* subplot for acceleration */
    plot = subplot.getSubplot(2, 0); 
    plot->label(PLOT_AXIS_X, "time (s)");
    plot->label(PLOT_AXIS_Y, "accel (m/s^2)"); // enhanced text for m/s^2
    plot->func2D(t0, tf, num, accel);
    plot->ticsRange(PLOT_AXIS_Y, 10);

    subplot.plotting();      // plot all subplots
}
