/* File: accelcharray.ch
   Calculate and plot accelerations using computational arrays */
#include <numeric.h> // for lindata(), sin(), and 'array' type qualifier
#include <chplot.h>  // for plotxy()

#define M_G 9.81     // gravitational acceleration constant g
#define N 100        // number of points for plotting 

int main() {
    array double a[N], t[N], p[N]; // declare computational arrays
    double mu, m, t0, tf;          // declare variables

    mu = 0.2;            // mu 
    m = 5.0;             // mass 
    t0 = 0.0;            // initial time 0 second 
    tf = 10.0;           // final time 10 seconds 
    lindata(t0, tf, t);  // fill array t from t0 to tf linearly 

    p = 4*(sin(t-3))+20; // p = 4sin(t-3)+20
    a = (p-mu*m*M_G)/m;  // a = (p-mu*m*M_G)/m 
    plotxy(t, a, N, "Acceleration Plot", "time (s)", "accel (m/s^2)");

    p = 4*(t.*t-3)+20;   // p = 4(t*t-3)+20
    a = (p-mu*m*M_G)/m;  // a = (p-mu*m*M_G)/m 
    plotxy(t, a, N, "Acceleration Plot", "time (s)", "accel (m/s^2)");
    return 0;
}
