/* File: defshape.ch 
   Use deferred shape arrays */
#include <array.h>   // for 'array' type qualifier
#define N 2
#define M 3

/* pass arrays of variable length using assumed-shape */
double defshape(array double a[:][:], int n, int m) {
    array double b[n][m];   // b is a deferred-shape array 
    double sum = 0;
    int i, j;

    b = a + 2 * a;        // matrix computation for b = 3*a
    for(i=0; i<n; i++)    // sum all elements of array a
      for(j=0; j<m; j++)
        sum += a[i][j];
    printf("b = \n%g", b);
    return sum;
}

int main() {
    double sum;
    array double a1[N][M] = {1, 2, 3,
                             4, 5, 6};

    sum = defshape(a1, N, M);
    printf("sum = %g\n",  sum);
    return 0;
}
