/* File: matrixexpr.c
   Calculate matrix formulas x = (A+B)v and y = 3A*C */
#include <stdio.h>

/* for multiplication A[M1][N1]*C[M2][N2], N1 must equal M2 */
#define M1 2 /* number of rows for A, B, v */
#define N1 3 /* number of columns for A, B */
#define M2 3 /* number of rows for C */
#define N2 2 /* number of columns for C */

int main() {
  /* declare and initialize matrices A, B, C and vector v */
  double a[M1][N1] = {{1,2,3},{4,5,6}};
  double b[M1][N1] = {{4,5,6},{7,8,9}};
  double c[M2][N2] = {{1,2},{3,4},{5,6}};
  double v[N1] = {1,2,3};
  /* declare x and y, and temporary variable D for (A+B) */
  double x[M1], y[M1][N2], d[M1][N1];
  int i, j, k;

  for(i=0; i<M1; i++) {
     for(j=0; j<N1; j++) {
        d[i][j] = a[i][j]+b[i][j]; /* calculate D = (A + B) */
     }
  }
  printf("x = \n");
  /* calculate D*v for (A+B)v */
  for(i=0; i<M1; i++) {
     x[i] = 0;
     for(j=0; j<N1; j++) {
        x[i] += d[i][j]*v[j]; /* calculate D*v */
     }
     printf("%g ", x[i]);
  }
  printf("\n");

  printf("y = \n");
  for(i=0; i<M1; i++) {
     for(j=0; j<N2; j++) {
        y[i][j] = 0;
        for(k=0; k<N1; k++) {
           y[i][j] += 3*a[i][k]*c[k][j]; /* calculate 3A*C */
        }
        printf("%g ", y[i][j]);
     }
     printf("\n");
  }
  return 0;
}
