/* File: matrixexpr.ch
   Calculate matrix formulas x = (A+B)v and y = 3A*C */
#include <stdio.h>
#include <array.h>  /* for 'array' type qualifier */

/* for multiplication A[M1][N1]*C[M2][N2], N1 must equal to M2 */
#define M1 2 /* number of rows for A, B, v */
#define N1 3 /* number of columns for A, B */
#define M2 3 /* number of rows for C */
#define N2 2 /* number of columns for C */

int main() {
  /* declare and initialize matrices A, B, C and vector v */
  array double a[M1][N1] = {{1,2,3},{4,5,6}};
  array double b[M1][N1] = {{4,5,6},{7,8,9}};
  array double c[M2][N2] = {{1,2},{3,4},{5,6}};
  array double v[N1] = {1,2,3};
  /* declare x and y */
  array double x[M1], y[M1][N2];

  x = (a+b)*v;               /* calculate x=(A+B)v */
  printf("x = \n%g", x);     /* display vector x */
  y = 3*a*c;                 /* calculate y=3A*C */
  printf("y = \n%g", y);     /* display matrix y */
  return 0;
}
