/* File: passvla.ch 
   Pass variable length arrays to a function  */
#include <stdio.h>
#include <array.h>   // for 'array' type qualifier

/* Function prototypes */ 
double sum2(int n, int m, array double a[n][m], array double b[n][m]);
double sum2(int n, int m, array double a[*][*], array double [*][*]);

/* function passes variable length arrays a and b */
double sum2(int n, int m, array double a[n][m], array double b[n][m]){
    double sum = 0;
    int i, j;

    printf("n = %d, m = %d\n", n, m); // print passed n and m
    b = a + 2 * a;        // matrix computation for b = 3*a
    for(i=0; i<n; i++)    // sum all elements of array a
       for(j=0; j<m; j++)
          sum += a[i][j];
    return sum;
}

int main() {
    double sum;
    array double b1[2][3], a1[2][3] = {1, 2, 3,
                                    4, 5, 6};
    array double b2[3][4], a2[3][4] = {1, 2, 3, 4,
                                    5, 6, 7, 8, 
                                    9, 10, 11, 12};

    sum = sum2(2, 3, a1, b1);      // pass 2x3 matrices a1 and b1
    printf("b1 = \n%g", b1);       // print b1 passed back from sum2()
    printf("sum = %g\n\n",  sum);
    sum = sum2(3, 4, a2, b2);      // pass 3x4 matrices a2 and b2
    printf("b2 = \n%g", b2);       // print b2 passed back from sum2()
    printf("sum = %g\n",  sum);
    return 0;
}
