/* File: interp2.ch */
#include <chplot.h>
#include <math.h>
#include <numeric.h>
#define M 20 
#define N 30 
#define NUM_X 40 
#define NUM_Y 50 

int main() {
    int i,j;
    array double za1[M*N],za[M][N],xa[M],ya[N];
    array double z1[NUM_X*NUM_Y],z[NUM_X][NUM_Y],x[NUM_X],y[NUM_Y];
    CPlot plot;

    /* Construct data set of the peaks function */
    linspace(xa, -3, 3);
    linspace(ya, -4, 4);
    for(i=0; i<M; i++) {
        for(j=0; j<N; j++) {
            za[i][j] = 3*(1-xa[i])*(1-xa[i])*
                       exp(-(xa[i]*xa[i])-(ya[j]+1)*(ya[j]+1))
                       - 10*(xa[i]/5 - xa[i]*xa[i]*xa[i]-
                       pow(ya[j],5))*exp(-xa[i]*xa[i]-ya[j]*ya[j])
                       - 1/3*exp(-(xa[i]+1)*(xa[i]+1)-ya[j]*ya[j]);
        }
    }
    linspace(x, -3, 3);
    linspace(y, -4, 4);
    interp2(z,x,y,xa,ya,za,"spline");

    za1 = (array double[M*N])za;
    /* add offset for display */
    z1 = (array double[NUM_X*NUM_Y])z + (array double[NUM_X*NUM_Y])50;
    plot.data3D(xa, ya, za1);
    plot.data3D(x, y, z1);
    plot.ticsLevel(0);
    plot.text("spline", PLOT_TEXT_RIGHT,4,4.5,55);
    plot.text("original", PLOT_TEXT_RIGHT,4,4.5,5);
    plot.plotting();
}
