/* File: poles.ch 
   Multiply polynomials and find poles of a transfer function */
#include <stdio.h>
#include <numeric.h> /* for conv() and roots() */

/* define dimensions for arrays */
#define N1 3        /* p1 = 2s^2 - 7s + 3 */
#define N2 3        /* p2 = s^2 + 2s + 101 */
#define N (N1+N2-1) /* den = (s^2 + 2s + 82)(s^2 + 2s + 101) */
#define NN (N-1)    /* roots for den = p1*p2 */

int main() {
   double p1[N1] = {2, -7, 3};  /* p1 = 2s^2 - 7s + 3 */
   double p2[N2] = {1, 2, 101}; /* p2 = s^2 + 2s + 101 */
   double den[N];               /* den = p1*p2 */
   complex poles[NN];           /* poles for denominator for den */
   int i;

   conv(den,p1,p2);  /* den = (2s^2 - 7s + 3)(s^2 + 2s + 101) 
                            =  2s^4 - 3s^3 + 191s^2 - 701s + 303 */
   printf("denominator ="); 
   for(i=0; i<N; i++) { 
     printf("%8.2f", den[i]); 
   }

   roots(poles, den);   /* find roots for den = p1*p2 */
   printf("\npoles = "); 
   for(i=0; i<NN; i++) { 
      printf("%g ", poles[i]); 
   }
   printf("\n"); 
   return 0;
}
