/* File: polyfit.ch */
#include <stdio.h>
#include <numeric.h>
#define NPT 100                 /* Number of data points */
#define NTERM 5                 /* Number of terms */

int main() {
    int i,j,status;
    array double  u[NPT],x[NPT],y[NPT],a[NTERM];

    /* Create a data set of NTERM order polynomial 
       with uniform random deviation*/
    linspace(x,0.1,0.1*NPT);
    y = 8*x.*x.*x.*x + 5*x.*x.*x + 3*x.*x + 6*x  + (array double[NPT])(7);
    urand(u); 
    y += 0.1*u;    

    status=polyfit(a,x,y);
    if(status) printf("Abnormal fit");
    printf("    %s\n","Coefficients");
    for (i=0;i<NTERM;i++)
        printf("    a[%1d] =  %8.6f \n",i,a[i]);
    printf("    y = %f at x = %f\n", polyeval(a, 2.0), 2.0);
}
