/* File: accelarray.c
   Calculate the acceleration using arrays for accel and time 
   using 11 points  */
#include <stdio.h>
#include <math.h>
#define M_G   9.81  /* gravitational acceleration constant g */
#define N     11    /* num of points for arrays a and t*/

int main() {
    double a[N], t[N];        /* arrays a for accel and t for time */
    double mu, m, p;          /* mu, m for mass, and p for force */
    double t0, tf;            /* initial and final times */
    int i;                    /* variable for array index */

    /* set mu, mass, initial time, and final time */
    mu = 0.2;                 /* set mu */
    m = 5.0;                  /* set mass to 5 kg */
    t0 = 0.0;                 /* initial time 0 */ 
    tf = 10.0;                /* final time 10 seconds */
    /* processing data */
    for(i=0; i<N; i++) {       /* using a for-loop to set t[i] and a[i] */
        t[i] = t0+i*(tf - t0)/(N-1); /* calculate t[i] */
        p = 4*sin(t[i]-3)+20;        /* use t[i] to calculate p */
        a[i] = (p-mu*m*M_G)/m;       /* calculate a[i] */
    }

    /* display the output */
    printf(" time (s)  accel (m/s^2)\n");
    printf("-------------------------\n");
    for(i=0; i<N; i++) {
        printf("%8.4f    %8.4f\n", t[i], a[i]);
    }
    return 0;
}
